var pageLoading = false; // To keep track of page loading status

var currentPage_BeforeBack = null;
var currentPage = null;
var firstLoad = true;

function loadPageinDiv(url, page, querystring, params, div) 
{
        var request =  new XMLHttpRequest();
        request.open("POST", url + page + '.asp' + querystring, true);
        request.setRequestHeader("Content-Type", "application/x-javascript;");
        
        if (params != null) {
                request.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=utf-8");
                request.setRequestHeader("Content-length", params.length);

        }
        
        
 
        request.onreadystatechange = function() {
        
                if (request.readyState == 4 && request.status == 200) {
                        if (request.responseText) {
                                displayHTML(request.responseText, div, currentPage, page);
                                // currentPage bör vara efter displayHTML
                                currentPage = page;
                                printNetworkConnectionStatus(true);
                                setLanguageLabels(page);
                                createPageAppleButtons(page);
                                setPageStartFocus(page);
                                
                                if (firstLoad) {
                                        window.resizeTo(originalWindowWidth, originalWindowHeight);
                                        firstLoad = false;
                                } else if (currentPage == 'searchpage') {
                                        closeInfobox();
                                }                         
                                pageLoading = false;
                        }
                } else if (request.readyState == 4 && request.status != 200) {
                        if (firstLoad)
                                printNetworkConnectionStatus(false);
                }
        };
        request.send(params);
        pageLoading = true;
} 

function displayHTML(html, div, prevPage, nextPage)
{
        document.getElementById(div).innerHTML = html;
        
        // Resize widget to fit infobox
        if (div == 'divInfoboxContent') {
                var infobox = document.getElementById('divInfobox');
                
                // marginTop kan måste ändras om man ändrar font eller annat som ändrar höjden på en rad
                var marginTop = 125; 
                //alert('document.getElementById(timetableRow_ + infoboxRow) = ' + document.getElementById('timetableRow_' + infoboxRow));
                var rowTop = document.getElementById('timetableRow_' + infoboxRow).offsetTop + document.getElementById('timetableRow_' + infoboxRow).offsetHeight - 25 /*- Math.round(infobox.offsetHeight/2)*/;
                var newTop = marginTop + rowTop;
                
                
                infobox.style.top = newTop + 'px';
                
                var margin = 30;
                var newWidth = infobox.offsetLeft + infobox.offsetWidth + margin;
                var newHeight = infobox.offsetTop + infobox.offsetHeight + margin;
                
                //Debug
                //newWidth = 900;
                //newHeight = 800;
                window.resizeTo(Math.max(originalWindowHeight, newWidth), Math.max(originalWindowHeight, newHeight));
                document.getElementById('divInfobox').style.visibility='visible';
                loadSpecificInfobox();
        }
        
        if (div == 'divMainContentBack') {
                currentPage_BeforeBack = currentPage;
                loadSpecificBack();
        }
        
        if (upPrevClick) {
                upPrevClick = false;
                closeInfobox();
                if (getNumberOfJourneysShown() > 0)
                        document.getElementById('timetableRow_' + (getNumberOfJourneysShown()-1)).onclick();
        }
        
         if (downNextClick) {
                downNextClick = false;
                closeInfobox();
                if (document.getElementById('timetableRow_0'))
                        document.getElementById('timetableRow_0').onclick();
        }
        
        if(div == 'divMainContentBack') { 
                //setCustomerSelect();
        
                document.getElementById('selectLanguage').selectedIndex = widget.preferenceForKey("language");
                
                setLanguageLabels('backpage');
                
                
                if (widget.preferenceForKey(createInstancePreferenceKey('startupState')) == null) {
                        document.getElementById('radioStartupState_1').checked = true;
                } else {
                        document.getElementById('radioStartupState_' + widget.preferenceForKey(dashcode.createInstancePreferenceKey('startupState'))).checked = true;
                }
                
                
                window.resizeTo(backWindowWidth, backWindowHeight);
        } 
        
        // Se till att infoboxen stannar kvar mellan tidigare/senare
        if (nextPage == 'resultspage' && prevPage == 'resultspage' && div == 'divMainContent') {
                if (infoboxRow != -1) {
                        if (document.getElementById('timetableRow_' + infoboxRow)) {
                                var prevInfoboxRow = infoboxRow;
                                infoboxRow = -1;
                                document.getElementById('timetableRow_' + prevInfoboxRow).onclick();
                        } else {
                                 if (document.getElementById('timetableRow_0'))
                                        document.getElementById('timetableRow_0').onclick();
                        }
                } 
        }
        
}

function getNumberOfJourneysShown()
{
        for (var i = 0; i < 10; i++) {
                if (!document.getElementById('timetableRow_' + i))
                        return i;
        }
}

function setPageStartFocus(page)
{      
        switch(page) {
                case 'searchpage':
                        if (document.getElementById('inpPointFr'))
                                document.getElementById('inpPointFr').focus();
                break;
                case 'querypage':
                        if (document.getElementById('selPointFr'))
                                document.getElementById('selPointFr').focus();
                break;
        }
}

// state true = error, state false = no error
function printNetworkConnectionStatus(networkState) 
{
        var errorDivVisibility = 'hidden';
        var normalDivVisibility = 'visible';
        if (!networkState) {
                errorDivVisibility = 'visible';
                normalDivVisibility = 'hidden';
                
                closeInfobox();
        }
        
        // Normal divs:
        var normalDivs = new Array('divReseplaneraren', 'mainbtnNewSearch', 'frontImg', 'imgFrontLogo', 'menuBracket', 'divFlip');
        // Error divs:
        var errorDivs = new Array('divNoNetworkConnection');
        
        for (var i = 0; i < normalDivs.length; i++) {
                document.getElementById(normalDivs[i]).style.visibility = normalDivVisibility;
        }
        
        
        for (var i = 0; i < errorDivs.length; i++) {
                document.getElementById(errorDivs[i]).style.visibility = errorDivVisibility;

        }

}


