function resetButton(button) 
{
        if (button) {
                button.remove();
                delete button;
        }
}

function createAppleButton(div, type, label, onclickFunction)
{
        if (document.getElementById(div))
                document.getElementById(div).innerHTML = "";
        
        var height = 18;
        var widthLeft = 9;
        var widthRight = 9;
        
        var typeLeft = 'normal';
        var typeMiddle = 'normal';
        var typeRight = 'normal';
        
        
        // Specialtyper
        switch (type) {
                case 'retour':
                        typeLeft = type;
                        widthLeft = 22;
                break;
                case 'previous':
                        typeLeft = type;
                        widthLeft = 16;
                break;
                case 'next':
                        typeRight = type;
                        widthRight = 16;
                break;
                
                
                
        }
        
        urlButtonMiddle = WIDGETURL + "customerSchemes/_common/button/normal_middle.png";
        urlButtonMiddleClicked = WIDGETURL + "customerSchemes/_common/button/normal_middle_clicked.png";
        
        if (typeLeft == "normal") {
                urlButtonLeft = WIDGETURL + "customerSchemes/_common/button/normal_left.png";
                urlButtonLeftClicked = WIDGETURL + "customerSchemes/_common/button/normal_left_clicked.png";
        } else {
                urlButtonLeft = getImgPath(typeLeft + '_left.png');
                urlButtonLeftClicked = getImgPath(typeLeft + '_left_clicked.png');
        }
        
        if (typeRight == "normal") {
                urlButtonRight = WIDGETURL + "customerSchemes/_common/button/normal_right.png";
                urlButtonRightClicked = WIDGETURL + "customerSchemes/_common/button/normal_right_clicked.png";
        } else {
                urlButtonRight = getImgPath(typeRight + '_right.png');
                urlButtonRightClicked = getImgPath(typeRight + '_right_clicked.png');
        }
        
        return new AppleButton(document.getElementById(div),
                                label,
                                height,
                                urlButtonLeft,
                                urlButtonLeftClicked,
                                widthLeft,
                                urlButtonMiddle,
                                urlButtonMiddleClicked,
                                urlButtonRight,
                                urlButtonRightClicked,
                                widthRight,
                                onclickFunction);
                                
}


function createPageAppleButtons(page)
{
        var currentLanguage = widget.preferenceForKey('language');
        if (currentLanguage == null) {
                currentLanguage = 0;
                widget.setPreferenceForKey(0, 'language');
        }

        var onclickFunction;
        
        // Create new
        switch(page) {
                case 'searchpage':

                        createAppleButton('divBtnSearch', 'normal', lanbtnSearch[currentLanguage], Function("showQueryPage('search');")); 
                break;
                case 'querypage':
                        // Kolla om det blivit nåt error
                        var querypageError = document.getElementById('resultspageError');
                        
                        if (querypageError) 
                                createAppleButton('divBtnNewSearch', 'normal', lanMainBtnNewSearch[currentLanguage], new Function("closeInfobox(); showSearchPage(null);"));
                        else {
                                // Om Bakåt-knappen ska skrivas ut, dvs när man kommer direkt från söksidan
                                if (document.getElementById('divBtnQueryPageBack'))
                                        createAppleButton('divBtnQueryPageBack', 'previous', lanbtnEdit[currentLanguage], Function("showSearchPage('edit');")); 
                                createAppleButton('divBtnSearch', 'normal', lanbtnSearch[currentLanguage], new Function("showResultsPage('search');")); 
                        }
                break;
                case 'resultspage':
                        // Kolla om det blivit nåt error
                        var resultspageError = document.getElementById('resultspageError');
                        
                       if (resultspageError)
                                createAppleButton('divBtnNewSearch', 'normal', lanMainBtnNewSearch[currentLanguage], new Function("closeInfobox(); showSearchPage(null);"));
                        else {

                                //createAppleButton('divResultsBtnEdit', 'normal', 'Redigera', new Function("closeInfobox(); showSearchPage('edit');"));
                                createAppleButton('divResultsBtnRetour', 'retour', lanbtnRetour[currentLanguage], new Function("closeInfobox(); showQueryPage('retour');"));
                                createAppleButton('divResultsBtnPrevious', 'previous', lanbtnPrevious[currentLanguage], new Function("showResultsPageChange('previous');")); 
                                createAppleButton('divResultsBtnNext', 'next', lanbtnNext[currentLanguage], new Function("showResultsPageChange('next');"));
                        }
                        
                break;
                
        }
}
